<template>
  <div>
    <div class="row">
      <div class="col-xs-12 col-md-6">
        <el-input
          v-model="search"
          placeholder="Rechercher sur le nom ou le numéro SIREN"
        />
      </div>
    </div>
    <div class="row">
      <el-table
        ref="sirensTable"
        :data="pagedAndFilteredSirens"
        :default-sort="{prop: 'createdAt', order: 'descending'}"
        border
        stripe
        style="width: 100%"
        @selection-change="handleSelectionChange"
      >
        <el-table-column
          prop="createdAt"
          label="Date d'ajout"
        >
          <template slot-scope="scope">
            {{ scope.row.createdAt.date | beautifulDate }}
          </template>
        </el-table-column>
        <el-table-column
          prop="name"
          label="Entreprise"
        />
        <el-table-column
          prop="number"
          label="Numéro SIREN"
        />
        <el-table-column
          prop="maxPersonnelNumbers"
          label="Effectif mensuel maximum"
        />
        <el-table-column
          prop="actions"
          label=""
          width="120"
        >
          <template slot-scope="scope">
            <click-button
              :disabled="isLoading"
              @click="editSiren(scope.row,scope.$index)"
            >
              <template slot="content">
                <edit-icon />
              </template>
            </click-button>
            <click-button
              v-if="editionMode===false && !isOn"
              :disabled="isLoading"
              @click="confirmDeleteSiren(scope.row)"
            >
              <template slot="content">
                <remove-icon />
              </template>
            </click-button>
          </template>
        </el-table-column>
      </el-table>
    </div>
    <div class="row">
      <el-pagination
        :current-page.sync="currentPage"
        :page-size="pageSize"
        layout="total, prev, pager, next"
        :total="filteredSirens.length"
        @current-change="handleCurrentChange"
      />
    </div>
    <div class="row">
      <p style="font-style: italic;">
        Ces données sont mises à jour automatiquement,
        100 éléments les plus récents affichés
      </p>
    </div>
    <input-protected-confirmation-modal
      id="confirmationModalDelete"
      text="Êtes-vous sûr de vouloir supprimer cette entreprise ?"
      :text-to-check="siren.number.toString()"
      check-label="Par mesure de sécurité, veuillez entrer une nouvelle fois le numéro SIREN à supprimer"
      @okClicked="performDeleteSiren"
    >
      <template #content>
        <p>Les éléments suivants seront suppirmés :</p>
        <ul>
          <li>Historique des envois des fichiers DSN</li>
          <li>Données DSN intégrées</li>
          <li>Archives DSN</li>
          <li>Documents partagés dans l'espace de ressources</li>
        </ul>
        <p class="alert-warning">
          <b>{{ toDeleteHtmlWarning }}</b>
        </p>
      </template>
    </input-protected-confirmation-modal>
  </div>
</template>

<script>
import {mapActions, mapGetters} from "vuex";
import ClickButton from "../../../components/Button/ClickButton";
import InputProtectedConfirmationModal from "../../../components/Modal/InputProtectedConfirmationModal";
import EditIcon from "../../../components/Icon/EditIcon";
import RemoveIcon from "../../../components/Icon/RemoveIcon";
import VanillaToasts from "vanillatoasts";

export default {
  name: "SirenTable",
  components: {
    ClickButton,
    InputProtectedConfirmationModal,
    EditIcon,
    RemoveIcon,
  },
  props: {
    editionMode: {
      type: Boolean,
      default: false
    },
  },
  data() {
    return {
      search: '',
      multipleSelection: [],
      currentPage: 1,
      pageSize: 10,
    }
  },
  computed: {
    toDeleteHtmlWarning() {
      let htmlText = ""
      if(this.countDsnFileToDelete !== 0 ) {
        if(this.countDsnFileToDelete ===1) {
          htmlText += this.countDsnFileToDelete+" fichier DSN sera supprimé. "
        }else {
          htmlText += this.countDsnFileToDelete+" fichiers DSN seront supprimés. "
        }
      }

      this.groupToDeleteMessages.forEach((message)=>{
        htmlText += message+" "
      })

      return htmlText
    },
    ...mapGetters([
      'groupToDeleteMessages',
      'isOn',
      'sirens',
      'siren',
      'isLoading',
      'countDsnFileToDelete',
    ]),
    pagedAndFilteredSirens() {
      return !this.search
        ?
        this.sirens.slice(this.pageSize * this.currentPage - this.pageSize, this.pageSize * this.currentPage)
        :
        this.filteredSirens.slice(this.pageSize * this.currentPage - this.pageSize, this.pageSize * this.currentPage)
    },
    filteredSirens() {
      return this.search ? this.sirens.filter(siren => (siren.name.toLowerCase()+siren.number.toString().toLowerCase()).includes(this.search.toLowerCase())) : this.sirens
    },
  },
  methods: {
    ...mapActions([
      'deleteSiren',
      'sirenToDelete'
    ]),
    handleCurrentChange(val) {
      this.currentPage = val
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    editSiren(siren,index) {
      this.$emit('edit', { index: index, id: siren.id, name: siren.name, number: siren.number, maxPersonnelNumbers: siren.maxPersonnelNumbers })
    },
    performDeleteSiren() {
      this.deleteSiren(this.siren.id).then(()=>{
        VanillaToasts.create({
          title: 'Suppression SIREN',
          text: 'Opération effectuée avec succès',
          type: 'success',
          timeout: 5000, // hide after 5000ms, // optional paremter
        });
      })
    },
    confirmDeleteSiren(siren) {
      this.sirenToDelete(siren).then(()=>{
        $('#confirmationModalDelete').modal({keyboard:false,backdrop:'static'})
      })
    },
  }
}
</script>

<style scoped>
.row {
  margin-top: 2vh;
}
</style>